//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                             StdDevSeries_Cls.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CMoving_Average                                   | 
//+X----------------------------------------------------------------X+ 
#include <MASeries_Cls.mqh> 
//+X----------------------------------------------------------------X+
//   CMovSeriesTools                                   | 
//+X----------------------------------------------------------------X+ 
#include <MovSeriesTools_Cls.mqh>
//+X================================================================X+
//|                           |
//+X================================================================X+
class CStdDeviation : public CMovSeriesTools
 {
public:
  double StdDevSeries(uint begin, //     
                       uint prev_calculated, //       
                       uint rates_total, //       
                       int Length, //  
                       double deviation, // 
                       double series,  //   ,      bar
                       double MovSeries, //  ,    StdDeviation
                       uint bar,  //  
                       bool set //   .
                       );
  protected:
  int    m_Size_, m_count;
  double m_Sum, m_SUM, m_Sum2, m_SUM2;
  double m_SeriesArray[];  
 };
//+X================================================================X+
//|                                  |
//+X================================================================X+    
double CStdDeviation::StdDevSeries
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int Length, //  
  double deviation, // 
  double series,  //   ,      bar
  double MovSeries, //  ,    StdDeviation
  uint bar,  //  
  bool set //   .
 )
// StdDevSeries(begin, prev_calculated, rates_total, period, deviation, Series, MovSeries, bar, set) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----      
  if (BarCheck1(begin, bar, set)) return(EMPTY_VALUE);
  
  //----+   
  int iii, kkk;
  double StdDev, m_SumX2;

  //----+    
   if(bar==begin && !SeriesArrayResize(__FUNCTION__, Length, m_SeriesArray, m_Size_))
      return(EMPTY_VALUE);
  
  //----+    Length  
  LengthCheck(Length);
      
  //----+    m_SeriesArray
  Recount_ArrayZeroPos(m_count, Length, prev_calculated, series, bar, m_SeriesArray);
  
  //----+  
  if(BarCheck2(begin, bar, set, Length))
   {
    m_Sum = 0.0;
    m_Sum2 = 0.0;
    for(iii = 1; iii < Length; iii++)
     {
      kkk = Recount_ArrayNumber(m_count, Length, iii); 
      m_Sum += m_SeriesArray[kkk];
      m_Sum2 += MathPow(m_SeriesArray[kkk], 2);
     }
   }              
  else if(BarCheck3(begin, bar, set, Length)) return(EMPTY_VALUE);
   
  //----+  StdDev
  m_Sum += series;
  m_Sum2 += MathPow(series, 2);
  m_SumX2 = Length * MathPow(MovSeries, 2) - 2 * MovSeries * m_Sum + m_Sum2;
  
  kkk = Recount_ArrayNumber(m_count, Length, Length - 1);
  m_Sum2 -=  MathPow(m_SeriesArray[kkk], 2);
  m_Sum -= m_SeriesArray[kkk];
  
  StdDev = deviation * MathSqrt(m_SumX2 / Length);
  
  //----+   
  if (BarCheck5(rates_total, bar, set))
   { 
    m_Sum = m_SUM;
    m_Sum2 = m_SUM2;
   }
   
  //----+   
  if (BarCheck4(rates_total, bar, set)) 
   {
    m_SUM = m_Sum;
    m_SUM2 = m_Sum2;
   }  
//----+
  return(StdDev); 
 }
//+X----------------------+ <<< The End >>> +-----------------------X+