/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+
//|                                                          AMA.mq5 |
//|              MQL4 Code:  Copyright  2004, GOODMAN & Mstera  AF |
//|              MQL5 Code:     Copyright  2010,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
//----  
#property copyright "Copyright  2004, by GOODMAN & Mstera  AF"
//----    
#property link      "http://forum.viac.ru/viewforum.php?f=7"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  Red
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "AMA"

//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int ama_period = 9; //  AMA
input int fast_ma_period = 2; //   
input int slow_ma_period = 30; //   
input double G = 2.0; // ,     
input int AMAShift = 0; //       
//+----------------------------------------------+
//----   ,    
                //      
double ExtLineBuffer[]; 
//+X================================================================X+
//   CAMA                                              |
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+
//| Custom indicator initialization function                         |
//+X================================================================X+  
void OnInit()
  {
//----+
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer, INDICATOR_DATA);
   //----       AMAShift
   PlotIndexSetInteger(0, PLOT_SHIFT, AMAShift);
   //----      
   PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, ama_period);
   //----      
   string shortname;
   StringConcatenate(shortname, "AMA(", ama_period, ")");
   //---      DataWindow
   PlotIndexSetString(0, PLOT_LABEL, shortname);   
   //---           
   IndicatorSetString(INDICATOR_SHORTNAME, shortname);
   //---     
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
   //---      
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
//----+
  }
//+X================================================================X+
//| Custom indicator iteration function                              |
//+X================================================================X+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[]     //     
               )
  {
//----+   
   //----       
   if (rates_total < ama_period + 1 + begin)
    return(0);
   
   //----    
   int first, bar; 

   //----    first    
   if (prev_calculated == 0) //      
    { 
     first = 0 + begin; //      
     //---      begin ,      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, ama_period + 2 + begin);
    }
   else 
    {
     first = prev_calculated - 1; //      
    }

   //----    CAMA   AMASeries_Cls.mqh
   static CAMA AMA1;

   //----    
   for(bar = first; bar < rates_total; bar++)
     ExtLineBuffer[bar] = AMA1.AMASeries(begin, prev_calculated, rates_total,
                           ama_period, fast_ma_period, slow_ma_period, G, price[bar], bar, false);
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+
