/*
 *  <<    >>
 *
 /*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 *
 *       :
 *
 * 1)    CMO -  /. 
 *  -   +50  ,    -50  .
 *     70/30   RSI. 
 * 2)  .  -   CMO    CMO 
 * ,  - ,   CMO    CMO  .
 */
//+X================================================================X+
//|                                   Chande Momentum Oscillator.mq5 |
//|              MQL5 Code:     Copyright  2010,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
//----  
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  Gold
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "CMO"
//----    
#property indicator_level1  80
#property indicator_level2  50
#property indicator_level3  20
#property indicator_levelcolor Magenta
#property indicator_levelstyle STYLE_DASHDOTDOT

//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int CMO_period = 9; //  CMO
input int CMO_Shift = 0; //      
//+----------------------------------------------+
//----   ,    
                //      
double ExtLineBuffer[]; 
//+X================================================================X+
//   CCMO                                              |
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+
//| Custom indicator initialization function                         |
//+X================================================================X+  
void OnInit()
  {
//----+
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer, INDICATOR_DATA);
   //----       VIDYAShift
   PlotIndexSetInteger(0, PLOT_SHIFT, CMO_Shift);
   //----      
   PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, CMO_period);
   //----      
   string shortname;
   StringConcatenate(shortname, "CMO(", CMO_period, ")");
   //---      DataWindow
   PlotIndexSetString(0, PLOT_LABEL, shortname);   
   //---           
   IndicatorSetString(INDICATOR_SHORTNAME, shortname);
   //---     
   IndicatorSetInteger(INDICATOR_DIGITS, 0);
   //---      
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
//----+
  }
//+X================================================================X+
//| Custom indicator iteration function                              |
//+X================================================================X+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[]     //     
               )
  {
//----+   
   //----       
   if (rates_total < CMO_period + 1 + begin)
    return(0);
   
   //----    
   int first, bar; 

   //----    first    
   if (prev_calculated == 0) //      
    { 
     first = 0 + begin; //      
     //---      begin ,      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, CMO_period + 2 + begin);
    }
   else 
    {
     first = prev_calculated - 1; //      
    }

   //----    CCMO
   static CCMO CMO1;

   //----    
   for(bar = first; bar < rates_total; bar++)
     ExtLineBuffer[bar] = CMO1.CMOSeries(begin, prev_calculated, rates_total, CMO_period, price[bar], bar, false) * 100;
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+
