/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+
//|                                                         EMAx.mq5 |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//----     
#property indicator_chart_window
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   2
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  LimeGreen
//----     
#property indicator_type2   DRAW_LINE
//----        
#property indicator_color2  Red

//----   
input double EMAPeriod1 = 13; //  EMA
input double EMAPeriod2 = 26; //  EMA
input int    EMAShift = 0; //  EMA    
input int    EMAPriceShift = 0; // EMA     

//---  
double ExtLineBuffer1[];
double ExtLineBuffer2[];

double dPriceShift;
//+X================================================================X+
//| Custom indicator initialization function                         |
//+X================================================================X+
void OnInit()
  {
//----+
   //----         
   string short_name = "EMA";
   IndicatorSetString(INDICATOR_SHORTNAME, short_name + "(" + 
                    DoubleToString(EMAPeriod1,2) +", " +DoubleToString(EMAPeriod2,2) + ")");
     
   //----   ,      
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer1, INDICATOR_DATA);
   //----        MAShift
   PlotIndexSetInteger(0, PLOT_SHIFT, EMAShift);
   
   PlotIndexSetDouble(1, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   //----    ExtLineBuffer   
   SetIndexBuffer(1, ExtLineBuffer2, INDICATOR_DATA);
   //----        MAShift
   PlotIndexSetInteger(1, PLOT_SHIFT, EMAShift);
   
   //----     
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
   //----    
   dPriceShift = _Point * EMAPriceShift;
//----+
  }
//+X================================================================X+
//   CMoving_Average                                   | 
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+ 
//|  Moving Average                                                  |
//+X================================================================X+
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+   
   //----       
   if (rates_total < begin)
    return(0);
   
   //----    
   int first, bar;
   
   //----    first    
   if (prev_calculated == 0) //      
    {
     first = begin; //      
    }
   else first = prev_calculated - 1; //      
   
   //----    CMoving_Average   MASeries_Cls.mqh
   static CMoving_Average EMA[2];
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----   .    EMASeries.  
     ExtLineBuffer1[bar] = EMA[0].EMASeries(begin, prev_calculated, rates_total, EMAPeriod1, price[bar], bar, false) + dPriceShift;
     ExtLineBuffer2[bar] = EMA[1].EMASeries(begin, prev_calculated, rates_total, EMAPeriod2, price[bar], bar, false) + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
