/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+ 
//|                                                       MAx3x1.mq5 | 
//|                               Copyright  2010, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        - 
#property indicator_color1 DarkOrchid
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "MAx4"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int Length1 = 3; //   SMA 
input int Length2 = 3; //   EMA 
input int Length3 = 3; //   SMMA  
input int Length4 = 3; //   LWMA                     
input int Shift = 0; //      
input int PriceShift = 0; //      
//+-----------------------------------+
//----  
double MAx4[];

int Handle;
int start;
double dPriceShift;
//+X================================================================X+
//   CMoving_Average                                   | 
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+    
//| MAx4 indicator initialization function                           | 
//+X================================================================X+  
void OnInit()
 {
//----+  
  //----      
  SetIndexBuffer(0, MAx4, INDICATOR_DATA);
  //----    1  
  PlotIndexSetInteger(0, PLOT_SHIFT, Shift);
  //----     
  start  = Length1  + Length3 + Length4;
  //----      
  PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
  //----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE, EMPTY_VALUE);
  //---      DataWindow
  PlotIndexSetString(0, PLOT_LABEL, "MAx4"); 
  //----      
  string shortname;
  StringConcatenate(shortname, "MAx4( SMA Length = ", Length1, ", EMA Length = ", Length2,
                                         ", SMMA Length = ", Length3, ", LWMA Length = ", Length4, ")");  
  //---           
  IndicatorSetString(INDICATOR_SHORTNAME, shortname);
  //---     
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
  //----    
  dPriceShift = _Point * PriceShift;
  
  //----+   
  Handle = iMA(NULL, 0, Length1, 0, MODE_SMA, PRICE_CLOSE);
  if (Handle == INVALID_HANDLE)Print("      iMA");
//----+  
 }
//+X================================================================X+  
//| MAx4 iteration function                                          | 
//+X================================================================X+  
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+
   start += begin;   
   //----       
   if (rates_total < start) return(0);

   //----   
   int to_copy, first, bar, bar_;
   //----       
   double ma1_[], ma2_, ma3_, ma4_;
   //----   
   static int start2, start3, start4;
   
   //----     OnCalculate()
   if(prev_calculated > rates_total || prev_calculated <= 0)//      
    {
     first = begin; //      
     to_copy = rates_total - begin; //    
     
     //----     
     start2 = Length1 + begin;
     start3 = Length1 + begin; //  EMA      
     start4 = Length1 + Length3 + begin;
     
     //---      begin ,
           //      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
    }
   else
    {
     first = prev_calculated - 1; //      
     to_copy = rates_total - prev_calculated + 1; //     
    }
    
   //----+       
   ArraySetAsSeries(ma1_, true);
   //---      
   if(CopyBuffer(Handle, 0, 0, to_copy, ma1_) <= 0) return(0);
    
   //----    CMoving_Average   MASeries_Cls.mqh
   static CMoving_Average MA2, MA3, MA4;
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----+    MASeries. 
     bar_ = rates_total - 1 - bar; 
     ma2_ = MA2.MASeries(start2, prev_calculated, rates_total, Length2, MODE_EMA,  ma1_[bar_], bar, false);
     ma3_ = MA3.MASeries(start3, prev_calculated, rates_total, Length3, MODE_SMMA, ma2_,       bar, false);
     ma4_ = MA4.MASeries(start4, prev_calculated, rates_total, Length4, MODE_LWMA, ma3_,       bar, false);
     //----       
     MAx4[bar] = ma4_ + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
